<?php
/**
 * @copyright	Copyright (C) 2010 - 2014 Peter Deed
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

	// no direct access
	defined('_JEXEC') or die;

    // Toolbar
    JToolBarHelper::title( 'Reportico Report Designer', 'reportico.png' );

    JToolbarHelper::preferences('com_reportico');
    JToolbarHelper::divider();

    $dir = dirname(__FILE__);

    $base = JURI::base();
    $base = dirname($base);

    // if imagesql parameter is passed then this is a reportico db image request.
    if ( isset ( $_REQUEST["reportico_call_mode"] ) && $_REQUEST["reportico_call_mode"] == "dbimage" )
    {
        require_once("../components/com_reportico/reportico.class.php");
        $reportico = new reportico();

        $app = JFactory::getApplication();
        define('SW_FRAMEWORK_DB_DRIVER','pdo_mysql');
        define('SW_FRAMEWORK_DB_USER',$app->getCfg('user'));
        define('SW_FRAMEWORK_DB_PASSWORD',$app->getCfg('password'));
        define('SW_FRAMEWORK_DB_HOST',$app->getCfg('hostname'));
        define('SW_FRAMEWORK_DB_DATABASE',$app->getCfg('db'));


        $reportico->set_project_environment($reportico->initial_project, $reportico->projects_folder, $reportico->admin_projects_folder);

        $datasource = new reportico_datasource();
        $datasource->connect();

        $imagesql = $_REQUEST["imagesql"];
        $rs = $datasource->ado_connection->Execute($imagesql)
            or die("Query failed : " . $ado_connection->ErrorMsg());
        $line = $rs->FetchRow();

        //header('Content-Type: image/gif');
        foreach ( $line as $col )
        {
            $data = $col;
            break;
        }
        echo $data;
        return false;
    }

    // if imagesql parameter is passed then this is a reportico db image request.
    if ( isset ( $_REQUEST["reportico_call_mode"] ) && $_REQUEST["reportico_call_mode"] == "graph_pchart" )
    {
        include_once("../components/com_reportico/dyngraph_pchart.php");
        return;
    }

    // if imagesql parameter is passed then this is a reportico db image request.
    if ( isset ( $_REQUEST["reportico_call_mode"] ) && $_REQUEST["reportico_call_mode"] == "graph_jpgraph" )
    {
        include_once("../components/com_reportico/dyngraph.php");
        return;
    }

    $app = JFactory::getApplication();
    $document = JFactory::getDocument();
    $username = false;
    $user = JFactory::getUser();
    if ( $user )
       $username = $user->username;


    $document->addScript($base. '/components/com_reportico/js/jquery.js');
    $document->addScript($base. '/components/com_reportico/js/ui/jquery-ui.js');
    $document->addStylesheet($base. '/components/com_reportico/js/ui/jquery-ui.css');
    $document->addScript($base . '/components/com_reportico/js/jquery.jdMenu.js');
    $document->addScript($base. '/components/com_reportico/js/reportico_joomla.js');

    $dir = dirname(__FILE__);
    
    date_default_timezone_set(@date_default_timezone_get());
	
    error_reporting(E_ALL);

    // Load reportico
    include_once("../components/com_reportico/reportico.class.php");

    $lang = JFactory::getLanguage();
    $dplang = get_datepicker_language($lang->getTag());
    $document->addScript($base. '/components/com_reportico/js/ui/i18n/jquery.ui.datepicker-'.$dplang.'.js');

    // Set Joomla extra parameters to be passed through on all Reportico links 
    // so that Reportico can be accessed as a component through Joomla
    $_SESSION["reportico"]["forward_url_get_parameters"] = "option=com_reportico&format=raw";

    // Instantiate Reportico
    $reportico = new reportico();
    $reportico->allow_maintain = "FULL";
    $reportico->allow_debug = true;
    $reportico->embedded_report = true;
    $reportico->reportico_ajax_preloaded = true;
    $reportico->reportico_ajax_script_url = "index.php";
    $reportico->framework_parent = true;
    $reportico->framework_type = "joomla";
    $reportico->external_user = $username;
    $reportico->drilldown_namespace = true;
    $reportico->forward_url_get_parameters = "option=com_reportico&format=raw";
    $reportico->force_reportico_mini_maintains = false;

    // Pull in module startup parameters
    $reportico_params = JComponentHelper::getParams('com_reportico');

    if ( isset($reportico_params) )
    {
        $error = false;

        if ( preg_match("/^2.5/", JVERSION ) )
            $style = "nobootstrap";
        else
            $style = $reportico_params->get("outputStyleAdmin", "bootstrap2preloaded");

        if ( $style == "bootstrapreportico" )
        {
            $reportico->bootstrap_styles = "3";
            $reportico->bootstrap_preloaded = false;
            $document->addScript($base . '/components/com_reportico/js/bootstrap3/js/bootstrap.min.js');
            $document->addStylesheet($base . '/components/com_reportico/js/bootstrap3/css/bootstrap.min.css');
        }
        else if ( $style == "bootstrap2preloaded" )
        {
            $reportico->bootstrap_styles = "2";
            $reportico->bootstrap_preloaded = true;
        }
        else if ( $style == "bootstrap3preloaded" )
        {
            $reportico->bootstrap_styles = "joomla3";
            $reportico->bootstrap_preloaded = true;
        }
        else
        {
            $reportico->bootstrap_styles = false;
            $reportico->bootstrap_preloaded = false;
            $document->addStylesheet( $base . '/components/com_reportico/css/reportico.css');
        }

        $reportico->pdf_engine = $reportico_params->get("pdfEngine", "tcpdf");
        $reportico->pdf_delivery_mode = "DOWNLOAD_NEW_WINDOW";


        $reportico->dynamic_grids = $reportico_params->get("dynamicGrids", "noDynamicGrids") == "dynamicGrids";
        if ( $reportico->dynamic_grids )
        {
            $reportico->dynamic_grids_sortable = ( $reportico_params->get("dynamicGridsSortable", "sortableDynamicGrids" ) == "sortableDynamicGrids" );
            $reportico->dynamic_grids_searchable = ( $reportico_params->get("dynamicGridsSearchable", "searchableDynamicGrids" ) == "searchableDynamicGrids" );
            $reportico->dynamic_grids_paging = ( $reportico_params->get("dynamicGridsPageable", "noPageableDynamicGrids" ) == "pageableDynamicGrids" );
            if ( $reportico->dynamic_grids_paging )
                    $reportico->dynamic_grids_page_size = $reportico_params->get("dynamicGridsPageSize", 10);
        }

        $document->addScript($base . '/components/com_reportico/js/jquery.dataTables.min.js');
        $document->addStylesheet($base . '/components/com_reportico/css/jquery.dataTables.css');
        $document->addScript($base . '/components/com_reportico/js/select2/js/select2.min.js');
        $document->addStylesheet($base . '/components/com_reportico/js/select2/css/select2.min.css');
        $document->addScript($base . '/components/com_reportico/js/download.js');

    }
    else
    {
        $reportico->bootstrap_styles = false;
        $reportico->bootstrap_preloaded = false;
        $document->addStylesheet(JURI::base() . $base . '/components/com_reportico/js/reportico.css');
    }  

    // If called from refresh or scratch restart the session
    if ( !JRequest::getVar('reportico_ajax_called') && !JRequest::getVar('new_reportico_window') && !JRequest::getVar('reportico_session_name'))
        $reportico->clear_reportico_session = 1;

    $reportico->charting_engine = "PCHART";
    if ( $reportico->charting_engine_html == "NVD3" )
    {
        $document->addScript($base . '/components/com_reportico/js/nvd3/d3.min.js');
        $document->addScript($base . '/components/com_reportico/js/nvd3/nv.d3.js');
        $document->addStylesheet($base . '/components/com_reportico/js/nvd3/nv.d3.css');
    }

    
    define('SW_FRAMEWORK_DB_DRIVER','pdo_mysql');
    define('SW_FRAMEWORK_DB_USER',$app->getCfg('user'));
    define('SW_FRAMEWORK_DB_PASSWORD',$app->getCfg('password'));
    define('SW_FRAMEWORK_DB_HOST',$app->getCfg('hostname'));
    define('SW_FRAMEWORK_DB_DATABASE',$app->getCfg('db'));

    // Generate Report Output
    $reportico->execute();
?>
