<?php
/**
 * @copyright	Copyright (C) 2005 - 2013 Peter Deed. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die;

/**
 * @package		Joomla.Site
 * @subpackage	mod_menu
 * @since		1.5
 */
class modReporticoHelper
{
	/**
	 * Get a list of the menu items.
	 *
	 * @param	JRegistry	$params	The module options.
	 *
	 * @return	array
	 * @since	1.5
	 */
	static function run (&$params)
	{
        $app = JFactory::getApplication();
        $document = JFactory::getDocument();

        // Set variable to tell reportico component that it is started from the module
        // and probably needs initializ
        $reportico_module_initialisation_parameters = array (
                "execute_mode" => $params->get('startMode', false),
                "project" => $params->get('startProject', false),
                "report" => $params->get('startReport', false),
                "reportsql" => $params->get('startSQL', false),
                "project_password" => $params->get('projectPassword', false),
                "access_mode" => $params->get('startAccessMode', false),
                "output_format" => $params->get('startOutputFormat', false),
                "output_style" => $params->get('startOutputStyle', false),
                "show_refresh_button" => $params->get('showRefreshButton', false),
                "output_show_detail" => $params->get('outputShowDetail', false),
                "output_show_graph" => $params->get('outputShowGraph', false),
                "output_show_group_headers" => $params->get('outputShowGroupHeaders', false),
                "output_show_group_trailers" => $params->get('outputShowGroupTrailers', false),
                "output_show_column_headers" => $params->get('outputShowColumnHeaders', false),
                "output_show_criteria" => $params->get('outputShowCriteria', false),
                "session_namespace" => $params->get('sessionNamespace', false),
                "report_param1" => $params->get('startReportParam1', false),
                "report_param2" => $params->get('startReportParam2', false),
                "report_param3" => $params->get('startReportParam3', false),
                "report_param4" => $params->get('startReportParam4', false),
                "report_param5" => $params->get('startReportParam5', false),
                "report_param6" => $params->get('startReportParam6', false),
                "report_param7" => $params->get('startReportParam7', false),
                "report_param8" => $params->get('startReportParam8', false),
                "report_param9" => $params->get('startReportParam9', false),
                "report_param10" => $params->get('startReportParam10', false),
                'output_show_control_panel' => $params->get('outputShowOutputControlPanel', "show"),
                'output_show_report_title' => $params->get('outputShowReportTitle', "show"),
                'output_show_html_button' => $params->get('outputShowHTMLButton', "show"),
                'output_show_print_html_button' => $params->get('outputShowPrintHTMLButton', "show"),
                'output_show_pdf_button' => $params->get('outputShowPDFButton', "show"),
                'output_show_csv_button' => $params->get('outputShowCSVButton', "show"),
                'output_show_style_panel' => $params->get('outputShowPageStyle', "show"),
                'output_show_navigation_menu' => $params->get('outputShowNavigationMenu', "show"),
                'output_show_dropdown_menu' => $params->get('outputShowDropdownMenu', "show"),
                'bootstrap_styles' => $params->get('outputBootstrapStyles', false),
                'charting_engine_html' => $params->get('chartingEngineHTML', false),
                'pdf_engine' => $params->get('pdfEngine', false),
                'dynamic_grids' => $params->get('dynamicGrids', false),
                'dynamic_grids_sortable' => $params->get('dynamicGridsSortable', false),
                'dynamic_grids_searchable' => $params->get('dynamicGridsSearchable', false),
                'dynamic_grids_pageable' => $params->get('dynamicGridsPageable', false),
                'dynamic_grids_page_size' => $params->get('dynamicGridsPageSize', false),
            );

        // Load reportico
        require('components/com_reportico/reportico.php');
        return;
	}
}
